//
// DO NOT MODIFY THIS FILE DIRECTLY!
// IT IS GENERATED BY generate_policy_source.py
// FROM ../../components/policy/resources/policy_templates.json
//

#include "components/policy/policy_constants.h"

#include <algorithm>
#include <climits>
#include <memory>

#include "base/logging.h"
#include "components/policy/core/common/policy_types.h"
#include "components/policy/core/common/schema_internal.h"
#include "components/policy/risk_tag.h"

namespace policy {

const PolicyDetails kChromePolicyDetails[] = {
//  is_deprecated  is_device_policy  id    max_external_data_size
  // AbusiveExperienceInterventionEnforce
  { false,         false,           404,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AdsSettingForIntrusiveAdsSites
  { false,         false,           409,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AllowCrossOriginAuthPrompt
  { false,         false,            89,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // AllowDeletingBrowserHistory
  { false,         false,           187,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_ADMIN_SHARING } },
  // AllowDinosaurEasterEgg
  { false,         false,           309,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AllowFileSelectionDialogs
  { false,         false,            84,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AllowOutdatedPlugins
  { false,         false,            81,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // AllowedDomainsForApps
  { false,         false,           331,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // AlternateErrorPagesEnabled
  { false,         false,             5,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AlwaysOpenPdfExternally
  { false,         false,           347,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AudioCaptureAllowed
  { false,         false,           160,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AudioCaptureAllowedUrls
  { false,         false,           208,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // AuthNegotiateDelegateWhitelist
  { false,         false,            30,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AuthSchemes
  { false,         false,            26,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AuthServerWhitelist
  { false,         false,            29,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AutoFillEnabled
  { false,         false,            18,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AutoSelectCertificateForUrls
  { false,         false,           102,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // AutofillCreditCardEnabled
  { false,         false,           392,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AutoplayAllowed
  { false,         false,           430,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AutoplayWhitelist
  { false,         false,           431,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BackgroundModeEnabled
  { false,         false,           138,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // BlockThirdPartyCookies
  { false,         false,            39,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BookmarkBarEnabled
  { false,         false,            82,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BrowserAddPersonEnabled
  { false,         false,           276,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BrowserGuestModeEnabled
  { false,         false,           275,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BrowserNetworkTimeQueriesEnabled
  { false,         false,           370,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BuiltInDnsClientEnabled
  { false,         false,           165,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CertificateTransparencyEnforcementDisabledForCas
  { false,         false,           435,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // CertificateTransparencyEnforcementDisabledForLegacyCas
  { false,         false,           436,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // CertificateTransparencyEnforcementDisabledForUrls
  { false,         false,           335,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // CloudPolicyOverridesMachinePolicy
  { false,         false,           381,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CloudPrintProxyEnabled
  { false,         false,            13,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CloudPrintSubmitEnabled
  { false,         false,           109,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ComponentUpdatesEnabled
  { false,         false,           342,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ContentPackDefaultFilteringBehavior
  { true,          false,           204,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ContentPackManualBehaviorHosts
  { true,          false,           205,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ContentPackManualBehaviorURLs
  { true,          false,           206,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CookiesAllowedForUrls
  { false,         false,            77,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CookiesBlockedForUrls
  { false,         false,            67,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CookiesSessionOnlyForUrls
  { false,         false,            68,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultBrowserSettingEnabled
  { false,         false,             3,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultCookiesSetting
  { false,         false,            48,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultDownloadDirectory
  { false,         false,           401,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // DefaultGeolocationSetting
  { false,         false,            54,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultImagesSetting
  { false,         false,            49,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultJavaScriptSetting
  { false,         false,            50,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultMediaStreamSetting
  { true,          false,           149,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultNotificationsSetting
  { false,         false,            53,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultPluginsSetting
  { false,         false,            51,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultPopupsSetting
  { false,         false,            52,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultPrinterSelection
  { false,         false,           308,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderAlternateURLs
  { false,         false,           161,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderEnabled
  { false,         false,            40,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderEncodings
  { false,         false,            47,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderIconURL
  { false,         false,            46,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderImageURL
  { false,         false,           229,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderImageURLPostParams
  { false,         false,           233,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderKeyword
  { false,         false,            42,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderName
  { false,         false,            41,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultSearchProviderNewTabURL
  { false,         false,           237,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderSearchURL
  { false,         false,            43,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultSearchProviderSearchURLPostParams
  { false,         false,           230,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderSuggestURL
  { false,         false,            44,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderSuggestURLPostParams
  { false,         false,           231,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultWebBluetoothGuardSetting
  { false,         false,           320,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultWebUsbGuardSetting
  { false,         false,           434,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DeveloperToolsAvailability
  { false,         false,           443,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DeveloperToolsDisabled
  { true,          false,            36,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // Disable3DAPIs
  { false,         false,            55,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisableAuthNegotiateCnameLookup
  { false,         false,            27,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisablePrintPreview
  { false,         false,           117,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisableSafeBrowsingProceedAnyway
  { false,         false,           150,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisableScreenshots
  { false,         false,           153,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisabledPlugins
  { true,          false,            19,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisabledPluginsExceptions
  { true,          false,            79,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisabledSchemes
  { true,          false,            85,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DiskCacheDir
  { false,         false,            88,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DiskCacheSize
  { false,         false,           110,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DownloadDirectory
  { false,         false,            64,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // DownloadRestrictions
  { false,         false,           371,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // EditBookmarksEnabled
  { false,         false,            83,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // EnableAuthNegotiatePort
  { false,         false,            28,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // EnableDeprecatedWebPlatformFeatures
  { false,         false,           270,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // EnableMediaRouter
  { false,         false,           333,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // EnableOnlineRevocationChecks
  { false,         false,           129,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // EnableSha1ForLocalAnchors
  { false,         false,           340,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // EnableSymantecLegacyInfrastructure
  { false,         false,           413,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // EnabledPlugins
  { true,          false,            78,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // ExtensionAllowedTypes
  { false,         false,           168,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ExtensionInstallBlacklist
  { false,         false,            32,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ExtensionInstallForcelist
  { false,         false,            34,                        0,
    { RISK_TAG_FULL_ADMIN_ACCESS, RISK_TAG_NONE } },
  // ExtensionInstallSources
  { false,         false,           148,                        0,
    { RISK_TAG_FULL_ADMIN_ACCESS, RISK_TAG_SYSTEM_SECURITY } },
  // ExtensionInstallWhitelist
  { false,         false,            33,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ExtensionSettings
  { false,         false,           278,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ForceEphemeralProfiles
  { false,         false,           245,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ForceGoogleSafeSearch
  { false,         false,           282,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // ForceSafeSearch
  { true,          false,           162,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // ForceYouTubeRestrict
  { false,         false,           348,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // ForceYouTubeSafetyMode
  { true,          false,           283,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // FullscreenAllowed
  { false,         false,           240,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // GSSAPILibraryName
  { false,         false,            31,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // HardwareAccelerationModeEnabled
  { false,         false,           304,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // HideWebStoreIcon
  { false,         false,           189,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // HomepageIsNewTabPage
  { false,         false,             2,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // HomepageLocation
  { false,         false,             1,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // Http09OnNonDefaultPortsEnabled
  { false,         false,           345,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ImagesAllowedForUrls
  { false,         false,            69,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ImagesBlockedForUrls
  { false,         false,            70,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ImportAutofillFormData
  { false,         false,           277,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportBookmarks
  { false,         false,            97,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportHistory
  { false,         false,            98,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportHomepage
  { false,         false,            99,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportSavedPasswords
  { false,         false,           101,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportSearchEngine
  { false,         false,           100,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // IncognitoEnabled
  { true,          false,            10,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // IncognitoModeAvailability
  { false,         false,            93,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // IsolateOrigins
  { false,         false,           398,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // JavaScriptAllowedForUrls
  { false,         false,            71,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // JavaScriptBlockedForUrls
  { false,         false,            72,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // JavascriptEnabled
  { true,          false,             9,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MachineLevelUserCloudPolicyEnrollmentToken
  { false,         false,           428,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ManagedBookmarks
  { false,         false,           227,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MaxConnectionsPerProxy
  { false,         false,            92,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MaxInvalidationFetchDelay
  { false,         false,           228,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MediaCacheSize
  { false,         false,           111,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MediaRouterCastAllowAllIPs
  { false,         false,           437,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MetricsReportingEnabled
  { false,         false,            15,                        0,
    { RISK_TAG_GOOGLE_SHARING, RISK_TAG_NONE } },
  // NativeMessagingBlacklist
  { false,         false,           251,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NativeMessagingUserLevelHosts
  { false,         false,           253,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NativeMessagingWhitelist
  { false,         false,           252,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NetworkPredictionOptions
  { false,         false,           273,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NewTabPageLocation
  { false,         false,           360,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NotificationsAllowedForUrls
  { false,         false,           105,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NotificationsBlockedForUrls
  { false,         false,           106,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NtlmV2Enabled
  { false,         false,           393,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // PacHttpsUrlStrippingEnabled
  { false,         false,           332,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // PasswordManagerEnabled
  { false,         false,            16,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PluginsAllowedForUrls
  { false,         false,            73,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PluginsBlockedForUrls
  { false,         false,            74,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PopupsAllowedForUrls
  { false,         false,            75,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PopupsBlockedForUrls
  { false,         false,            76,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PrintPreviewUseSystemDefaultPrinter
  { false,         false,           373,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PrintingEnabled
  { false,         false,            12,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PromptForDownloadLocation
  { false,         false,           395,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyBypassList
  { false,         false,            25,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyMode
  { false,         false,            21,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyPacUrl
  { false,         false,            24,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyServer
  { false,         false,            23,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyServerMode
  { true,          false,            22,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxySettings
  { false,         false,           116,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // QuicAllowed
  { false,         false,           301,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RegisteredProtocolHandlers
  { false,         false,           268,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RelaunchNotification
  { false,         false,           419,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RelaunchNotificationPeriod
  { false,         false,           420,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostAllowClientPairing
  { false,         false,           234,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostAllowGnubbyAuth
  { false,         false,           257,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostAllowRelayedConnection
  { false,         false,           263,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostClientDomain
  { true,          false,           316,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostClientDomainList
  { false,         false,           369,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostDomain
  { true,          false,           154,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostDomainList
  { false,         false,           368,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostFirewallTraversal
  { false,         false,            95,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostMatchUsername
  { false,         false,           285,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostRequireCurtain
  { false,         false,           157,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // RemoteAccessHostTalkGadgetPrefix
  { false,         false,           156,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostTokenUrl
  { false,         false,           286,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // RemoteAccessHostTokenValidationCertificateIssuer
  { false,         false,           288,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostTokenValidationUrl
  { false,         false,           287,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // RemoteAccessHostUdpPortRange
  { false,         false,           264,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RequireOnlineRevocationChecksForLocalAnchors
  { false,         false,           235,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RestoreOnStartup
  { false,         false,            37,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RestoreOnStartupURLs
  { false,         false,            38,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RestrictSigninToPattern
  { false,         false,           147,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RunAllFlashInAllowMode
  { false,         false,           391,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SSLErrorOverrideAllowed
  { false,         false,           300,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SSLVersionMax
  { false,         false,           361,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SSLVersionMin
  { false,         false,           279,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SafeBrowsingEnabled
  { false,         false,            14,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SafeBrowsingExtendedReportingEnabled
  { false,         false,           429,                        0,
    { RISK_TAG_GOOGLE_SHARING, RISK_TAG_NONE } },
  // SafeBrowsingExtendedReportingOptInAllowed
  { true,          false,           299,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SafeBrowsingWhitelistDomains
  { false,         false,           422,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SavingBrowserHistoryDisabled
  { false,         false,            11,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SearchSuggestEnabled
  { false,         false,             6,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SecurityKeyPermitAttestation
  { false,         false,           402,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // ShowAppsShortcutInBookmarkBar
  { false,         false,           267,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ShowCastIconInToolbar
  { false,         false,           362,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ShowHomeButton
  { false,         false,            35,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SigninAllowed
  { true,          false,           190,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SitePerProcess
  { false,         false,           399,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SpellCheckServiceEnabled
  { false,         false,           151,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SpellcheckEnabled
  { false,         false,           408,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SpellcheckLanguage
  { false,         false,           405,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SupervisedUserCreationEnabled
  { false,         false,           223,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SuppressUnsupportedOSWarning
  { false,         false,           324,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SyncDisabled
  { false,         false,            20,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_GOOGLE_SHARING } },
  // TaskManagerEndProcessEnabled
  { false,         false,           327,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // TranslateEnabled
  { false,         false,            80,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // URLBlacklist
  { false,         false,           103,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // URLWhitelist
  { false,         false,           104,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // UnsafelyTreatInsecureOriginAsSecure
  { false,         false,           400,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // VariationsRestrictParameter
  { false,         false,           196,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // VideoCaptureAllowed
  { false,         false,           167,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // VideoCaptureAllowedUrls
  { false,         false,           209,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // WPADQuickCheckEnabled
  { false,         false,           261,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // WebDriverOverridesIncompatiblePolicies
  { false,         false,           414,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // WebRtcUdpPortRange
  { false,         false,           339,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // WebUsbAskForUrls
  { false,         false,           439,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // WebUsbBlockedForUrls
  { false,         false,           440,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
};

const internal::SchemaNode kSchemas[] = {
//  Type                          Extra
  { base::Value::Type::DICTIONARY,    9 },  // root node
  { base::Value::Type::BOOLEAN,      -1 },  // simple type: boolean
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): AdsSettingForIntrusiveAdsSites
  { base::Value::Type::STRING,       -1 },  // simple type: string
  { base::Value::Type::LIST,          3 },  // simple type: stringlist
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): ContentPackDefaultFilteringBehavior
  { base::Value::Type::DICTIONARY,    0 },  // ContentPackManualBehaviorHosts
  { base::Value::Type::DICTIONARY,    1 },  // ContentPackManualBehaviorURLs
  { base::Value::Type::INTEGER,       2 },  // integer with enumeration restriction: DefaultCookiesSetting
  { base::Value::Type::INTEGER,       3 },  // integer with enumeration restriction (use range instead): DefaultGeolocationSetting
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): DefaultImagesSetting
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): DefaultJavaScriptSetting
  { base::Value::Type::INTEGER,       4 },  // integer with enumeration restriction (use range instead): DefaultMediaStreamSetting
  { base::Value::Type::INTEGER,       3 },  // integer with enumeration restriction (use range instead): DefaultNotificationsSetting
  { base::Value::Type::INTEGER,       3 },  // integer with enumeration restriction (use range instead): DefaultPluginsSetting
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): DefaultPopupsSetting
  { base::Value::Type::INTEGER,       4 },  // integer with enumeration restriction (use range instead): DefaultWebBluetoothGuardSetting
  { base::Value::Type::INTEGER,       4 },  // integer with enumeration restriction (use range instead): DefaultWebUsbGuardSetting
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): DeveloperToolsAvailability
  { base::Value::Type::INTEGER,      -1 },  // simple type: integer
  { base::Value::Type::INTEGER,       5 },  // integer with enumeration restriction (use range instead): DownloadRestrictions
  { base::Value::Type::DICTIONARY,    5 },  // ExtensionSettings
  { base::Value::Type::DICTIONARY,    2 },  // *
  { base::Value::Type::STRING,        6 },  // string with enumeration restriction: installation_mode
  { base::Value::Type::DICTIONARY,    3 },  // ^update_url:
  { base::Value::Type::STRING,        7 },  // string with enumeration restriction: installation_mode
  { base::Value::Type::DICTIONARY,    4 },  // ^[a-p]{32}$
  { base::Value::Type::STRING,        8 },  // string with enumeration restriction: installation_mode
  { base::Value::Type::STRING,        9 },  // string with pattern restriction: minimum_version_required
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): ForceYouTubeRestrict
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): IncognitoModeAvailability
  { base::Value::Type::DICTIONARY,    6 },  // items of ManagedBookmarks
  { base::Value::Type::LIST,         31 },  // 
  { base::Value::Type::LIST,         31 },  // 
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): NetworkPredictionOptions
  { base::Value::Type::STRING,       10 },  // string with enumeration restriction: ProxyMode
  { base::Value::Type::INTEGER,       5 },  // integer with enumeration restriction (use range instead): ProxyServerMode
  { base::Value::Type::DICTIONARY,    7 },  // ProxySettings
  { base::Value::Type::DICTIONARY,    8 },  // items of RegisteredProtocolHandlers
  { base::Value::Type::LIST,         38 },  // 
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): RelaunchNotification
  { base::Value::Type::INTEGER,      11 },  // integer with ranged restriction: RelaunchNotificationPeriod
  { base::Value::Type::INTEGER,      12 },  // integer with enumeration restriction: RestoreOnStartup
  { base::Value::Type::STRING,       13 },  // string with enumeration restriction: SSLVersionMax
  { base::Value::Type::STRING,       14 },  // string with enumeration restriction: SSLVersionMin
};

const internal::PropertyNode kPropertyNodes[] = {
//  Property                                          #Schema
  { "allowed_types",                                        4 },
  { "blocked_install_message",                              3 },
  { "blocked_permissions",                                  4 },
  { "install_sources",                                      4 },
  { "installation_mode",                                   23 },
  { "runtime_allowed_hosts",                                4 },
  { "runtime_blocked_hosts",                                4 },
  { "allowed_permissions",                                  4 },
  { "blocked_permissions",                                  4 },
  { "installation_mode",                                   25 },
  { "allowed_permissions",                                  4 },
  { "blocked_install_message",                              3 },
  { "blocked_permissions",                                  4 },
  { "installation_mode",                                   27 },
  { "minimum_version_required",                            28 },
  { "runtime_allowed_hosts",                                4 },
  { "runtime_blocked_hosts",                                4 },
  { "update_url",                                           3 },
  { "*",                                                   22 },
  { "^update_url:",                                        24 },
  { "^[a-p]{32}$",                                         26 },
  { "children",                                            32 },
  { "name",                                                 3 },
  { "toplevel_name",                                        3 },
  { "url",                                                  3 },
  { key::kProxyBypassList,                                  3 },
  { key::kProxyMode,                                        3 },
  { key::kProxyPacUrl,                                      3 },
  { key::kProxyServer,                                      3 },
  { key::kProxyServerMode,                                  3 },
  { "default",                                              1 },
  { "protocol",                                             3 },
  { "url",                                                  3 },
  { key::kAbusiveExperienceInterventionEnforce,             1 },
  { key::kAdsSettingForIntrusiveAdsSites,                   2 },
  { key::kAllowCrossOriginAuthPrompt,                       1 },
  { key::kAllowDeletingBrowserHistory,                      1 },
  { key::kAllowDinosaurEasterEgg,                           1 },
  { key::kAllowFileSelectionDialogs,                        1 },
  { key::kAllowOutdatedPlugins,                             1 },
  { key::kAllowedDomainsForApps,                            3 },
  { key::kAlternateErrorPagesEnabled,                       1 },
  { key::kAlwaysOpenPdfExternally,                          1 },
  { key::kAudioCaptureAllowed,                              1 },
  { key::kAudioCaptureAllowedUrls,                          4 },
  { key::kAuthNegotiateDelegateWhitelist,                   3 },
  { key::kAuthSchemes,                                      3 },
  { key::kAuthServerWhitelist,                              3 },
  { key::kAutoFillEnabled,                                  1 },
  { key::kAutoSelectCertificateForUrls,                     4 },
  { key::kAutofillCreditCardEnabled,                        1 },
  { key::kAutoplayAllowed,                                  1 },
  { key::kAutoplayWhitelist,                                4 },
  { key::kBackgroundModeEnabled,                            1 },
  { key::kBlockThirdPartyCookies,                           1 },
  { key::kBookmarkBarEnabled,                               1 },
  { key::kBrowserAddPersonEnabled,                          1 },
  { key::kBrowserGuestModeEnabled,                          1 },
  { key::kBrowserNetworkTimeQueriesEnabled,                 1 },
  { key::kBuiltInDnsClientEnabled,                          1 },
  { key::kCertificateTransparencyEnforcementDisabledForCas,      4 },
  { key::kCertificateTransparencyEnforcementDisabledForLegacyCas,      4 },
  { key::kCertificateTransparencyEnforcementDisabledForUrls,      4 },
  { key::kCloudPolicyOverridesMachinePolicy,                1 },
  { key::kCloudPrintProxyEnabled,                           1 },
  { key::kCloudPrintSubmitEnabled,                          1 },
  { key::kComponentUpdatesEnabled,                          1 },
  { key::kContentPackDefaultFilteringBehavior,              5 },
  { key::kContentPackManualBehaviorHosts,                   6 },
  { key::kContentPackManualBehaviorURLs,                    7 },
  { key::kCookiesAllowedForUrls,                            4 },
  { key::kCookiesBlockedForUrls,                            4 },
  { key::kCookiesSessionOnlyForUrls,                        4 },
  { key::kDefaultBrowserSettingEnabled,                     1 },
  { key::kDefaultCookiesSetting,                            8 },
  { key::kDefaultDownloadDirectory,                         3 },
  { key::kDefaultGeolocationSetting,                        9 },
  { key::kDefaultImagesSetting,                            10 },
  { key::kDefaultJavaScriptSetting,                        11 },
  { key::kDefaultMediaStreamSetting,                       12 },
  { key::kDefaultNotificationsSetting,                     13 },
  { key::kDefaultPluginsSetting,                           14 },
  { key::kDefaultPopupsSetting,                            15 },
  { key::kDefaultPrinterSelection,                          3 },
  { key::kDefaultSearchProviderAlternateURLs,               4 },
  { key::kDefaultSearchProviderEnabled,                     1 },
  { key::kDefaultSearchProviderEncodings,                   4 },
  { key::kDefaultSearchProviderIconURL,                     3 },
  { key::kDefaultSearchProviderImageURL,                    3 },
  { key::kDefaultSearchProviderImageURLPostParams,          3 },
  { key::kDefaultSearchProviderKeyword,                     3 },
  { key::kDefaultSearchProviderName,                        3 },
  { key::kDefaultSearchProviderNewTabURL,                   3 },
  { key::kDefaultSearchProviderSearchURL,                   3 },
  { key::kDefaultSearchProviderSearchURLPostParams,         3 },
  { key::kDefaultSearchProviderSuggestURL,                  3 },
  { key::kDefaultSearchProviderSuggestURLPostParams,        3 },
  { key::kDefaultWebBluetoothGuardSetting,                 16 },
  { key::kDefaultWebUsbGuardSetting,                       17 },
  { key::kDeveloperToolsAvailability,                      18 },
  { key::kDeveloperToolsDisabled,                           1 },
  { key::kDisable3DAPIs,                                    1 },
  { key::kDisableAuthNegotiateCnameLookup,                  1 },
  { key::kDisablePrintPreview,                              1 },
  { key::kDisableSafeBrowsingProceedAnyway,                 1 },
  { key::kDisableScreenshots,                               1 },
  { key::kDisabledPlugins,                                  4 },
  { key::kDisabledPluginsExceptions,                        4 },
  { key::kDisabledSchemes,                                  4 },
  { key::kDiskCacheDir,                                     3 },
  { key::kDiskCacheSize,                                   19 },
  { key::kDownloadDirectory,                                3 },
  { key::kDownloadRestrictions,                            20 },
  { key::kEditBookmarksEnabled,                             1 },
  { key::kEnableAuthNegotiatePort,                          1 },
  { key::kEnableDeprecatedWebPlatformFeatures,              4 },
  { key::kEnableMediaRouter,                                1 },
  { key::kEnableOnlineRevocationChecks,                     1 },
  { key::kEnableSha1ForLocalAnchors,                        1 },
  { key::kEnableSymantecLegacyInfrastructure,               1 },
  { key::kEnabledPlugins,                                   4 },
  { key::kExtensionAllowedTypes,                            4 },
  { key::kExtensionInstallBlacklist,                        4 },
  { key::kExtensionInstallForcelist,                        4 },
  { key::kExtensionInstallSources,                          4 },
  { key::kExtensionInstallWhitelist,                        4 },
  { key::kExtensionSettings,                               21 },
  { key::kForceEphemeralProfiles,                           1 },
  { key::kForceGoogleSafeSearch,                            1 },
  { key::kForceSafeSearch,                                  1 },
  { key::kForceYouTubeRestrict,                            29 },
  { key::kForceYouTubeSafetyMode,                           1 },
  { key::kFullscreenAllowed,                                1 },
  { key::kGSSAPILibraryName,                                3 },
  { key::kHardwareAccelerationModeEnabled,                  1 },
  { key::kHideWebStoreIcon,                                 1 },
  { key::kHomepageIsNewTabPage,                             1 },
  { key::kHomepageLocation,                                 3 },
  { key::kHttp09OnNonDefaultPortsEnabled,                   1 },
  { key::kImagesAllowedForUrls,                             4 },
  { key::kImagesBlockedForUrls,                             4 },
  { key::kImportAutofillFormData,                           1 },
  { key::kImportBookmarks,                                  1 },
  { key::kImportHistory,                                    1 },
  { key::kImportHomepage,                                   1 },
  { key::kImportSavedPasswords,                             1 },
  { key::kImportSearchEngine,                               1 },
  { key::kIncognitoEnabled,                                 1 },
  { key::kIncognitoModeAvailability,                       30 },
  { key::kIsolateOrigins,                                   3 },
  { key::kJavaScriptAllowedForUrls,                         4 },
  { key::kJavaScriptBlockedForUrls,                         4 },
  { key::kJavascriptEnabled,                                1 },
  { key::kMachineLevelUserCloudPolicyEnrollmentToken,       3 },
  { key::kManagedBookmarks,                                33 },
  { key::kMaxConnectionsPerProxy,                          19 },
  { key::kMaxInvalidationFetchDelay,                       19 },
  { key::kMediaCacheSize,                                  19 },
  { key::kMediaRouterCastAllowAllIPs,                       1 },
  { key::kMetricsReportingEnabled,                          1 },
  { key::kNativeMessagingBlacklist,                         4 },
  { key::kNativeMessagingUserLevelHosts,                    1 },
  { key::kNativeMessagingWhitelist,                         4 },
  { key::kNetworkPredictionOptions,                        34 },
  { key::kNewTabPageLocation,                               3 },
  { key::kNotificationsAllowedForUrls,                      4 },
  { key::kNotificationsBlockedForUrls,                      4 },
  { key::kNtlmV2Enabled,                                    1 },
  { key::kPacHttpsUrlStrippingEnabled,                      1 },
  { key::kPasswordManagerEnabled,                           1 },
  { key::kPluginsAllowedForUrls,                            4 },
  { key::kPluginsBlockedForUrls,                            4 },
  { key::kPopupsAllowedForUrls,                             4 },
  { key::kPopupsBlockedForUrls,                             4 },
  { key::kPrintPreviewUseSystemDefaultPrinter,              1 },
  { key::kPrintingEnabled,                                  1 },
  { key::kPromptForDownloadLocation,                        1 },
  { key::kProxyBypassList,                                  3 },
  { key::kProxyMode,                                       35 },
  { key::kProxyPacUrl,                                      3 },
  { key::kProxyServer,                                      3 },
  { key::kProxyServerMode,                                 36 },
  { key::kProxySettings,                                   37 },
  { key::kQuicAllowed,                                      1 },
  { key::kRegisteredProtocolHandlers,                      39 },
  { key::kRelaunchNotification,                            40 },
  { key::kRelaunchNotificationPeriod,                      41 },
  { key::kRemoteAccessHostAllowClientPairing,               1 },
  { key::kRemoteAccessHostAllowGnubbyAuth,                  1 },
  { key::kRemoteAccessHostAllowRelayedConnection,           1 },
  { key::kRemoteAccessHostClientDomain,                     3 },
  { key::kRemoteAccessHostClientDomainList,                 4 },
  { key::kRemoteAccessHostDomain,                           3 },
  { key::kRemoteAccessHostDomainList,                       4 },
  { key::kRemoteAccessHostFirewallTraversal,                1 },
  { key::kRemoteAccessHostMatchUsername,                    1 },
  { key::kRemoteAccessHostRequireCurtain,                   1 },
  { key::kRemoteAccessHostTalkGadgetPrefix,                 3 },
  { key::kRemoteAccessHostTokenUrl,                         3 },
  { key::kRemoteAccessHostTokenValidationCertificateIssuer,      3 },
  { key::kRemoteAccessHostTokenValidationUrl,               3 },
  { key::kRemoteAccessHostUdpPortRange,                     3 },
  { key::kRequireOnlineRevocationChecksForLocalAnchors,      1 },
  { key::kRestoreOnStartup,                                42 },
  { key::kRestoreOnStartupURLs,                             4 },
  { key::kRestrictSigninToPattern,                          3 },
  { key::kRunAllFlashInAllowMode,                           1 },
  { key::kSSLErrorOverrideAllowed,                          1 },
  { key::kSSLVersionMax,                                   43 },
  { key::kSSLVersionMin,                                   44 },
  { key::kSafeBrowsingEnabled,                              1 },
  { key::kSafeBrowsingExtendedReportingEnabled,             1 },
  { key::kSafeBrowsingExtendedReportingOptInAllowed,        1 },
  { key::kSafeBrowsingWhitelistDomains,                     4 },
  { key::kSavingBrowserHistoryDisabled,                     1 },
  { key::kSearchSuggestEnabled,                             1 },
  { key::kSecurityKeyPermitAttestation,                     4 },
  { key::kShowAppsShortcutInBookmarkBar,                    1 },
  { key::kShowCastIconInToolbar,                            1 },
  { key::kShowHomeButton,                                   1 },
  { key::kSigninAllowed,                                    1 },
  { key::kSitePerProcess,                                   1 },
  { key::kSpellCheckServiceEnabled,                         1 },
  { key::kSpellcheckEnabled,                                1 },
  { key::kSpellcheckLanguage,                               4 },
  { key::kSupervisedUserCreationEnabled,                    1 },
  { key::kSuppressUnsupportedOSWarning,                     1 },
  { key::kSyncDisabled,                                     1 },
  { key::kTaskManagerEndProcessEnabled,                     1 },
  { key::kTranslateEnabled,                                 1 },
  { key::kURLBlacklist,                                     4 },
  { key::kURLWhitelist,                                     4 },
  { key::kUnsafelyTreatInsecureOriginAsSecure,              4 },
  { key::kVariationsRestrictParameter,                      3 },
  { key::kVideoCaptureAllowed,                              1 },
  { key::kVideoCaptureAllowedUrls,                          4 },
  { key::kWPADQuickCheckEnabled,                            1 },
  { key::kWebDriverOverridesIncompatiblePolicies,           1 },
  { key::kWebRtcUdpPortRange,                               3 },
  { key::kWebUsbAskForUrls,                                 4 },
  { key::kWebUsbBlockedForUrls,                             4 },
};

const internal::PropertiesNode kProperties[] = {
//  Begin    End  PatternEnd Additional Properties
  {     0,     0,          0,     1 },  // ContentPackManualBehaviorHosts
  {     0,     0,          0,     1 },  // ContentPackManualBehaviorURLs
  {     0,     7,          7,    -1 },  // *
  {     7,    10,         10,    -1 },  // ^update_url:
  {    10,    18,         18,    -1 },  // ^[a-p]{32}$
  {    18,    19,         21,    -1 },  // ExtensionSettings
  {    21,    25,         25,    -1 },  // items of ManagedBookmarks
  {    25,    30,         30,    -1 },  // ProxySettings
  {    30,    33,         33,    -1 },  // items of RegisteredProtocolHandlers
  {    33,   241,        241,    -1 },  // root node
};

const internal::RestrictionNode kRestrictionNodes[] = {
//   FIRST, SECOND
  {{ 2,          1}},
  {{ 2,          0}},
  {{ 0,          3}},
  {{ 3,          1}},
  {{ 3,          2}},
  {{ 3,          0}},
  {{ 0,          2}},
  {{ 2,          4}},
  {{ 4,          8}},
  {{ 8,          8}},
  {{ 9,         14}},
  {{ INT_MAX, 3600000}},
  {{ 3,          6}},
  {{ 14,        16}},
  {{ 16,        19}},
};

const int kIntegerEnumerations[] = {
  1,
  2,
  4,
  1,
  4,
  5,
};

const char* const kStringEnumerations[] = {
  "blocked",
  "allowed",
  "blocked",
  "allowed",
  "blocked",
  "allowed",
  "force_installed",
  "normal_installed",
  "^[0-9]+([.][0-9]+)*$",
  "direct",
  "auto_detect",
  "pac_script",
  "fixed_servers",
  "system",
  "tls1.2",
  "tls1.3",
  "tls1",
  "tls1.1",
  "tls1.2",
};

const internal::SchemaData kChromeSchemaData = {
  kSchemas,
  kPropertyNodes,
  kProperties,
  kRestrictionNodes,
  kIntegerEnumerations,
  kStringEnumerations,
};


namespace {
bool CompareKeys(const internal::PropertyNode& node,
                 const std::string& key) {
  return node.key < key;
}

}  // namespace

const internal::SchemaData* GetChromeSchemaData() {
  return &kChromeSchemaData;
}

#if defined (OS_CHROMEOS)
void SetEnterpriseUsersDefaults(PolicyMap* policy_map) {
  if (!policy_map->Get(key::kAllowDinosaurEasterEgg)) {
    policy_map->Set(key::kAllowDinosaurEasterEgg,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(false),
                    nullptr);
  }
  if (!policy_map->Get(key::kArcBackupRestoreServiceEnabled)) {
    policy_map->Set(key::kArcBackupRestoreServiceEnabled,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(0),
                    nullptr);
  }
  if (!policy_map->Get(key::kArcEnabled)) {
    policy_map->Set(key::kArcEnabled,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(false),
                    nullptr);
  }
  if (!policy_map->Get(key::kArcGoogleLocationServicesEnabled)) {
    policy_map->Set(key::kArcGoogleLocationServicesEnabled,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(0),
                    nullptr);
  }
  if (!policy_map->Get(key::kCaptivePortalAuthenticationIgnoresProxy)) {
    policy_map->Set(key::kCaptivePortalAuthenticationIgnoresProxy,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(false),
                    nullptr);
  }
  if (!policy_map->Get(key::kCastReceiverEnabled)) {
    policy_map->Set(key::kCastReceiverEnabled,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(false),
                    nullptr);
  }
  if (!policy_map->Get(key::kChromeOsMultiProfileUserBehavior)) {
    policy_map->Set(key::kChromeOsMultiProfileUserBehavior,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>("primary-only"),
                    nullptr);
  }
  if (!policy_map->Get(key::kEasyUnlockAllowed)) {
    policy_map->Set(key::kEasyUnlockAllowed,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(false),
                    nullptr);
  }
  if (!policy_map->Get(key::kInstantTetheringAllowed)) {
    policy_map->Set(key::kInstantTetheringAllowed,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(false),
                    nullptr);
  }
  if (!policy_map->Get(key::kNTPContentSuggestionsEnabled)) {
    policy_map->Set(key::kNTPContentSuggestionsEnabled,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(false),
                    nullptr);
  }
  if (!policy_map->Get(key::kPacHttpsUrlStrippingEnabled)) {
    policy_map->Set(key::kPacHttpsUrlStrippingEnabled,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(false),
                    nullptr);
  }
  if (!policy_map->Get(key::kQuickUnlockModeWhitelist)) {
    auto default_value = std::make_unique<base::ListValue>();
    policy_map->Set(key::kQuickUnlockModeWhitelist,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::move(default_value),
                    nullptr);
  }
}
#endif

const PolicyDetails* GetChromePolicyDetails(const std::string& policy) {
  // First index in kPropertyNodes of the Chrome policies.
  static const int begin_index = 33;
  // One-past-the-end of the Chrome policies in kPropertyNodes.
  static const int end_index = 241;
  const internal::PropertyNode* begin =
      kPropertyNodes + begin_index;
  const internal::PropertyNode* end = kPropertyNodes + end_index;
  const internal::PropertyNode* it =
      std::lower_bound(begin, end, policy, CompareKeys);
  if (it == end || it->key != policy)
    return NULL;
  // This relies on kPropertyNodes from begin_index to end_index
  // having exactly the same policies (and in the same order) as
  // kChromePolicyDetails, so that binary searching on the first
  // gets the same results as a binary search on the second would.
  // However, kPropertyNodes has the policy names and
  // kChromePolicyDetails doesn't, so we obtain the index into
  // the second array by searching the first to avoid duplicating
  // the policy name pointers.
  // Offsetting |it| from |begin| here obtains the index we're
  // looking for.
  size_t index = it - begin;
  CHECK_LT(index, arraysize(kChromePolicyDetails));
  return kChromePolicyDetails + index;
}

namespace key {

const char kAbusiveExperienceInterventionEnforce[] = "AbusiveExperienceInterventionEnforce";
const char kAdditionalLaunchParameters[] = "AdditionalLaunchParameters";
const char kAdsSettingForIntrusiveAdsSites[] = "AdsSettingForIntrusiveAdsSites";
const char kAllowCrossOriginAuthPrompt[] = "AllowCrossOriginAuthPrompt";
const char kAllowDeletingBrowserHistory[] = "AllowDeletingBrowserHistory";
const char kAllowDinosaurEasterEgg[] = "AllowDinosaurEasterEgg";
const char kAllowFileSelectionDialogs[] = "AllowFileSelectionDialogs";
const char kAllowKioskAppControlChromeVersion[] = "AllowKioskAppControlChromeVersion";
const char kAllowOutdatedPlugins[] = "AllowOutdatedPlugins";
const char kAllowScreenLock[] = "AllowScreenLock";
const char kAllowScreenWakeLocks[] = "AllowScreenWakeLocks";
const char kAllowedDomainsForApps[] = "AllowedDomainsForApps";
const char kAllowedLocales[] = "AllowedLocales";
const char kAlternateErrorPagesEnabled[] = "AlternateErrorPagesEnabled";
const char kAlwaysAuthorizePlugins[] = "AlwaysAuthorizePlugins";
const char kAlwaysOpenPdfExternally[] = "AlwaysOpenPdfExternally";
const char kApplicationLocaleValue[] = "ApplicationLocaleValue";
const char kArcAppInstallEventLoggingEnabled[] = "ArcAppInstallEventLoggingEnabled";
const char kArcBackupRestoreEnabled[] = "ArcBackupRestoreEnabled";
const char kArcBackupRestoreServiceEnabled[] = "ArcBackupRestoreServiceEnabled";
const char kArcCertificatesSyncMode[] = "ArcCertificatesSyncMode";
const char kArcEnabled[] = "ArcEnabled";
const char kArcGoogleLocationServicesEnabled[] = "ArcGoogleLocationServicesEnabled";
const char kArcLocationServiceEnabled[] = "ArcLocationServiceEnabled";
const char kArcPolicy[] = "ArcPolicy";
const char kAttestationEnabledForDevice[] = "AttestationEnabledForDevice";
const char kAttestationEnabledForUser[] = "AttestationEnabledForUser";
const char kAttestationExtensionWhitelist[] = "AttestationExtensionWhitelist";
const char kAttestationForContentProtectionEnabled[] = "AttestationForContentProtectionEnabled";
const char kAudioCaptureAllowed[] = "AudioCaptureAllowed";
const char kAudioCaptureAllowedUrls[] = "AudioCaptureAllowedUrls";
const char kAudioOutputAllowed[] = "AudioOutputAllowed";
const char kAuthAndroidNegotiateAccountType[] = "AuthAndroidNegotiateAccountType";
const char kAuthNegotiateDelegateWhitelist[] = "AuthNegotiateDelegateWhitelist";
const char kAuthSchemes[] = "AuthSchemes";
const char kAuthServerWhitelist[] = "AuthServerWhitelist";
const char kAutoCleanUpStrategy[] = "AutoCleanUpStrategy";
const char kAutoFillEnabled[] = "AutoFillEnabled";
const char kAutoSelectCertificateForUrls[] = "AutoSelectCertificateForUrls";
const char kAutofillCreditCardEnabled[] = "AutofillCreditCardEnabled";
const char kAutoplayAllowed[] = "AutoplayAllowed";
const char kAutoplayWhitelist[] = "AutoplayWhitelist";
const char kBackgroundModeEnabled[] = "BackgroundModeEnabled";
const char kBlockThirdPartyCookies[] = "BlockThirdPartyCookies";
const char kBookmarkBarEnabled[] = "BookmarkBarEnabled";
const char kBrowserAddPersonEnabled[] = "BrowserAddPersonEnabled";
const char kBrowserGuestModeEnabled[] = "BrowserGuestModeEnabled";
const char kBrowserNetworkTimeQueriesEnabled[] = "BrowserNetworkTimeQueriesEnabled";
const char kBuiltInDnsClientEnabled[] = "BuiltInDnsClientEnabled";
const char kCaptivePortalAuthenticationIgnoresProxy[] = "CaptivePortalAuthenticationIgnoresProxy";
const char kCastReceiverEnabled[] = "CastReceiverEnabled";
const char kCastReceiverName[] = "CastReceiverName";
const char kCertificateTransparencyEnforcementDisabledForCas[] = "CertificateTransparencyEnforcementDisabledForCas";
const char kCertificateTransparencyEnforcementDisabledForLegacyCas[] = "CertificateTransparencyEnforcementDisabledForLegacyCas";
const char kCertificateTransparencyEnforcementDisabledForUrls[] = "CertificateTransparencyEnforcementDisabledForUrls";
const char kChromeCleanupEnabled[] = "ChromeCleanupEnabled";
const char kChromeCleanupReportingEnabled[] = "ChromeCleanupReportingEnabled";
const char kChromeFrameContentTypes[] = "ChromeFrameContentTypes";
const char kChromeFrameRendererSettings[] = "ChromeFrameRendererSettings";
const char kChromeOsLockOnIdleSuspend[] = "ChromeOsLockOnIdleSuspend";
const char kChromeOsMultiProfileUserBehavior[] = "ChromeOsMultiProfileUserBehavior";
const char kChromeOsReleaseChannel[] = "ChromeOsReleaseChannel";
const char kChromeOsReleaseChannelDelegated[] = "ChromeOsReleaseChannelDelegated";
const char kClearSiteDataOnExit[] = "ClearSiteDataOnExit";
const char kCloudPolicyOverridesMachinePolicy[] = "CloudPolicyOverridesMachinePolicy";
const char kCloudPrintProxyEnabled[] = "CloudPrintProxyEnabled";
const char kCloudPrintSubmitEnabled[] = "CloudPrintSubmitEnabled";
const char kComponentUpdatesEnabled[] = "ComponentUpdatesEnabled";
const char kContentPackDefaultFilteringBehavior[] = "ContentPackDefaultFilteringBehavior";
const char kContentPackManualBehaviorHosts[] = "ContentPackManualBehaviorHosts";
const char kContentPackManualBehaviorURLs[] = "ContentPackManualBehaviorURLs";
const char kContextualSearchEnabled[] = "ContextualSearchEnabled";
const char kCookiesAllowedForUrls[] = "CookiesAllowedForUrls";
const char kCookiesBlockedForUrls[] = "CookiesBlockedForUrls";
const char kCookiesSessionOnlyForUrls[] = "CookiesSessionOnlyForUrls";
const char kDHEEnabled[] = "DHEEnabled";
const char kDataCompressionProxyEnabled[] = "DataCompressionProxyEnabled";
const char kDefaultBrowserSettingEnabled[] = "DefaultBrowserSettingEnabled";
const char kDefaultCookiesSetting[] = "DefaultCookiesSetting";
const char kDefaultDownloadDirectory[] = "DefaultDownloadDirectory";
const char kDefaultGeolocationSetting[] = "DefaultGeolocationSetting";
const char kDefaultImagesSetting[] = "DefaultImagesSetting";
const char kDefaultJavaScriptSetting[] = "DefaultJavaScriptSetting";
const char kDefaultKeygenSetting[] = "DefaultKeygenSetting";
const char kDefaultMediaStreamSetting[] = "DefaultMediaStreamSetting";
const char kDefaultNotificationsSetting[] = "DefaultNotificationsSetting";
const char kDefaultPluginsSetting[] = "DefaultPluginsSetting";
const char kDefaultPopupsSetting[] = "DefaultPopupsSetting";
const char kDefaultPrinterSelection[] = "DefaultPrinterSelection";
const char kDefaultSearchProviderAlternateURLs[] = "DefaultSearchProviderAlternateURLs";
const char kDefaultSearchProviderEnabled[] = "DefaultSearchProviderEnabled";
const char kDefaultSearchProviderEncodings[] = "DefaultSearchProviderEncodings";
const char kDefaultSearchProviderIconURL[] = "DefaultSearchProviderIconURL";
const char kDefaultSearchProviderImageURL[] = "DefaultSearchProviderImageURL";
const char kDefaultSearchProviderImageURLPostParams[] = "DefaultSearchProviderImageURLPostParams";
const char kDefaultSearchProviderInstantURL[] = "DefaultSearchProviderInstantURL";
const char kDefaultSearchProviderInstantURLPostParams[] = "DefaultSearchProviderInstantURLPostParams";
const char kDefaultSearchProviderKeyword[] = "DefaultSearchProviderKeyword";
const char kDefaultSearchProviderName[] = "DefaultSearchProviderName";
const char kDefaultSearchProviderNewTabURL[] = "DefaultSearchProviderNewTabURL";
const char kDefaultSearchProviderSearchTermsReplacementKey[] = "DefaultSearchProviderSearchTermsReplacementKey";
const char kDefaultSearchProviderSearchURL[] = "DefaultSearchProviderSearchURL";
const char kDefaultSearchProviderSearchURLPostParams[] = "DefaultSearchProviderSearchURLPostParams";
const char kDefaultSearchProviderSuggestURL[] = "DefaultSearchProviderSuggestURL";
const char kDefaultSearchProviderSuggestURLPostParams[] = "DefaultSearchProviderSuggestURLPostParams";
const char kDefaultWebBluetoothGuardSetting[] = "DefaultWebBluetoothGuardSetting";
const char kDefaultWebUsbGuardSetting[] = "DefaultWebUsbGuardSetting";
const char kDeveloperToolsAvailability[] = "DeveloperToolsAvailability";
const char kDeveloperToolsDisabled[] = "DeveloperToolsDisabled";
const char kDeviceAllowBluetooth[] = "DeviceAllowBluetooth";
const char kDeviceAllowNewUsers[] = "DeviceAllowNewUsers";
const char kDeviceAllowRedeemChromeOsRegistrationOffers[] = "DeviceAllowRedeemChromeOsRegistrationOffers";
const char kDeviceAppPack[] = "DeviceAppPack";
const char kDeviceAutoUpdateDisabled[] = "DeviceAutoUpdateDisabled";
const char kDeviceAutoUpdateP2PEnabled[] = "DeviceAutoUpdateP2PEnabled";
const char kDeviceBlockDevmode[] = "DeviceBlockDevmode";
const char kDeviceDataRoamingEnabled[] = "DeviceDataRoamingEnabled";
const char kDeviceEcryptfsMigrationStrategy[] = "DeviceEcryptfsMigrationStrategy";
const char kDeviceEphemeralUsersEnabled[] = "DeviceEphemeralUsersEnabled";
const char kDeviceGuestModeEnabled[] = "DeviceGuestModeEnabled";
const char kDeviceHostnameTemplate[] = "DeviceHostnameTemplate";
const char kDeviceIdleLogoutTimeout[] = "DeviceIdleLogoutTimeout";
const char kDeviceIdleLogoutWarningDuration[] = "DeviceIdleLogoutWarningDuration";
const char kDeviceKerberosEncryptionTypes[] = "DeviceKerberosEncryptionTypes";
const char kDeviceLocalAccountAutoLoginBailoutEnabled[] = "DeviceLocalAccountAutoLoginBailoutEnabled";
const char kDeviceLocalAccountAutoLoginDelay[] = "DeviceLocalAccountAutoLoginDelay";
const char kDeviceLocalAccountAutoLoginId[] = "DeviceLocalAccountAutoLoginId";
const char kDeviceLocalAccountPromptForNetworkWhenOffline[] = "DeviceLocalAccountPromptForNetworkWhenOffline";
const char kDeviceLocalAccounts[] = "DeviceLocalAccounts";
const char kDeviceLoginScreenAppInstallList[] = "DeviceLoginScreenAppInstallList";
const char kDeviceLoginScreenAutoSelectCertificateForUrls[] = "DeviceLoginScreenAutoSelectCertificateForUrls";
const char kDeviceLoginScreenDefaultHighContrastEnabled[] = "DeviceLoginScreenDefaultHighContrastEnabled";
const char kDeviceLoginScreenDefaultLargeCursorEnabled[] = "DeviceLoginScreenDefaultLargeCursorEnabled";
const char kDeviceLoginScreenDefaultScreenMagnifierType[] = "DeviceLoginScreenDefaultScreenMagnifierType";
const char kDeviceLoginScreenDefaultSpokenFeedbackEnabled[] = "DeviceLoginScreenDefaultSpokenFeedbackEnabled";
const char kDeviceLoginScreenDefaultVirtualKeyboardEnabled[] = "DeviceLoginScreenDefaultVirtualKeyboardEnabled";
const char kDeviceLoginScreenDomainAutoComplete[] = "DeviceLoginScreenDomainAutoComplete";
const char kDeviceLoginScreenInputMethods[] = "DeviceLoginScreenInputMethods";
const char kDeviceLoginScreenIsolateOrigins[] = "DeviceLoginScreenIsolateOrigins";
const char kDeviceLoginScreenLocales[] = "DeviceLoginScreenLocales";
const char kDeviceLoginScreenPowerManagement[] = "DeviceLoginScreenPowerManagement";
const char kDeviceLoginScreenSaverId[] = "DeviceLoginScreenSaverId";
const char kDeviceLoginScreenSaverTimeout[] = "DeviceLoginScreenSaverTimeout";
const char kDeviceLoginScreenSitePerProcess[] = "DeviceLoginScreenSitePerProcess";
const char kDeviceMachinePasswordChangeRate[] = "DeviceMachinePasswordChangeRate";
const char kDeviceMetricsReportingEnabled[] = "DeviceMetricsReportingEnabled";
const char kDeviceNativePrinters[] = "DeviceNativePrinters";
const char kDeviceNativePrintersAccessMode[] = "DeviceNativePrintersAccessMode";
const char kDeviceNativePrintersBlacklist[] = "DeviceNativePrintersBlacklist";
const char kDeviceNativePrintersWhitelist[] = "DeviceNativePrintersWhitelist";
const char kDeviceOffHours[] = "DeviceOffHours";
const char kDeviceOpenNetworkConfiguration[] = "DeviceOpenNetworkConfiguration";
const char kDevicePolicyRefreshRate[] = "DevicePolicyRefreshRate";
const char kDeviceQuirksDownloadEnabled[] = "DeviceQuirksDownloadEnabled";
const char kDeviceRebootOnShutdown[] = "DeviceRebootOnShutdown";
const char kDeviceRollbackAllowedMilestones[] = "DeviceRollbackAllowedMilestones";
const char kDeviceRollbackToTargetVersion[] = "DeviceRollbackToTargetVersion";
const char kDeviceSamlLoginAuthenticationType[] = "DeviceSamlLoginAuthenticationType";
const char kDeviceSecondFactorAuthentication[] = "DeviceSecondFactorAuthentication";
const char kDeviceShowUserNamesOnSignin[] = "DeviceShowUserNamesOnSignin";
const char kDeviceStartUpFlags[] = "DeviceStartUpFlags";
const char kDeviceStartUpUrls[] = "DeviceStartUpUrls";
const char kDeviceTargetVersionPrefix[] = "DeviceTargetVersionPrefix";
const char kDeviceTransferSAMLCookies[] = "DeviceTransferSAMLCookies";
const char kDeviceUpdateAllowedConnectionTypes[] = "DeviceUpdateAllowedConnectionTypes";
const char kDeviceUpdateHttpDownloadsEnabled[] = "DeviceUpdateHttpDownloadsEnabled";
const char kDeviceUpdateScatterFactor[] = "DeviceUpdateScatterFactor";
const char kDeviceUserPolicyLoopbackProcessingMode[] = "DeviceUserPolicyLoopbackProcessingMode";
const char kDeviceUserWhitelist[] = "DeviceUserWhitelist";
const char kDeviceVariationsRestrictParameter[] = "DeviceVariationsRestrictParameter";
const char kDeviceWallpaperImage[] = "DeviceWallpaperImage";
const char kDisable3DAPIs[] = "Disable3DAPIs";
const char kDisableAuthNegotiateCnameLookup[] = "DisableAuthNegotiateCnameLookup";
const char kDisablePluginFinder[] = "DisablePluginFinder";
const char kDisablePrintPreview[] = "DisablePrintPreview";
const char kDisableSSLRecordSplitting[] = "DisableSSLRecordSplitting";
const char kDisableSafeBrowsingProceedAnyway[] = "DisableSafeBrowsingProceedAnyway";
const char kDisableScreenshots[] = "DisableScreenshots";
const char kDisableSpdy[] = "DisableSpdy";
const char kDisabledPlugins[] = "DisabledPlugins";
const char kDisabledPluginsExceptions[] = "DisabledPluginsExceptions";
const char kDisabledSchemes[] = "DisabledSchemes";
const char kDiskCacheDir[] = "DiskCacheDir";
const char kDiskCacheSize[] = "DiskCacheSize";
const char kDisplayRotationDefault[] = "DisplayRotationDefault";
const char kDnsPrefetchingEnabled[] = "DnsPrefetchingEnabled";
const char kDownloadDirectory[] = "DownloadDirectory";
const char kDownloadRestrictions[] = "DownloadRestrictions";
const char kDriveDisabled[] = "DriveDisabled";
const char kDriveDisabledOverCellular[] = "DriveDisabledOverCellular";
const char kEasyUnlockAllowed[] = "EasyUnlockAllowed";
const char kEcryptfsMigrationStrategy[] = "EcryptfsMigrationStrategy";
const char kEditBookmarksEnabled[] = "EditBookmarksEnabled";
const char kEnableAuthNegotiatePort[] = "EnableAuthNegotiatePort";
const char kEnableCommonNameFallbackForLocalAnchors[] = "EnableCommonNameFallbackForLocalAnchors";
const char kEnableDeprecatedWebBasedSignin[] = "EnableDeprecatedWebBasedSignin";
const char kEnableDeprecatedWebPlatformFeatures[] = "EnableDeprecatedWebPlatformFeatures";
const char kEnableMediaRouter[] = "EnableMediaRouter";
const char kEnableMemoryInfo[] = "EnableMemoryInfo";
const char kEnableOnlineRevocationChecks[] = "EnableOnlineRevocationChecks";
const char kEnableOriginBoundCerts[] = "EnableOriginBoundCerts";
const char kEnableSha1ForLocalAnchors[] = "EnableSha1ForLocalAnchors";
const char kEnableSymantecLegacyInfrastructure[] = "EnableSymantecLegacyInfrastructure";
const char kEnableSyncConsent[] = "EnableSyncConsent";
const char kEnabledPlugins[] = "EnabledPlugins";
const char kEnterpriseWebStoreName[] = "EnterpriseWebStoreName";
const char kEnterpriseWebStoreURL[] = "EnterpriseWebStoreURL";
const char kExtensionAllowedTypes[] = "ExtensionAllowedTypes";
const char kExtensionCacheSize[] = "ExtensionCacheSize";
const char kExtensionInstallBlacklist[] = "ExtensionInstallBlacklist";
const char kExtensionInstallForcelist[] = "ExtensionInstallForcelist";
const char kExtensionInstallSources[] = "ExtensionInstallSources";
const char kExtensionInstallWhitelist[] = "ExtensionInstallWhitelist";
const char kExtensionSettings[] = "ExtensionSettings";
const char kExternalStorageDisabled[] = "ExternalStorageDisabled";
const char kExternalStorageReadOnly[] = "ExternalStorageReadOnly";
const char kForceBrowserSignin[] = "ForceBrowserSignin";
const char kForceEphemeralProfiles[] = "ForceEphemeralProfiles";
const char kForceGoogleSafeSearch[] = "ForceGoogleSafeSearch";
const char kForceMaximizeOnFirstRun[] = "ForceMaximizeOnFirstRun";
const char kForceSafeSearch[] = "ForceSafeSearch";
const char kForceYouTubeRestrict[] = "ForceYouTubeRestrict";
const char kForceYouTubeSafetyMode[] = "ForceYouTubeSafetyMode";
const char kFullscreenAllowed[] = "FullscreenAllowed";
const char kGCFUserDataDir[] = "GCFUserDataDir";
const char kGSSAPILibraryName[] = "GSSAPILibraryName";
const char kHardwareAccelerationModeEnabled[] = "HardwareAccelerationModeEnabled";
const char kHeartbeatEnabled[] = "HeartbeatEnabled";
const char kHeartbeatFrequency[] = "HeartbeatFrequency";
const char kHideWebStoreIcon[] = "HideWebStoreIcon";
const char kHideWebStorePromo[] = "HideWebStorePromo";
const char kHighContrastEnabled[] = "HighContrastEnabled";
const char kHomepageIsNewTabPage[] = "HomepageIsNewTabPage";
const char kHomepageLocation[] = "HomepageLocation";
const char kHttp09OnNonDefaultPortsEnabled[] = "Http09OnNonDefaultPortsEnabled";
const char kIdleAction[] = "IdleAction";
const char kIdleActionAC[] = "IdleActionAC";
const char kIdleActionBattery[] = "IdleActionBattery";
const char kIdleDelayAC[] = "IdleDelayAC";
const char kIdleDelayBattery[] = "IdleDelayBattery";
const char kIdleWarningDelayAC[] = "IdleWarningDelayAC";
const char kIdleWarningDelayBattery[] = "IdleWarningDelayBattery";
const char kImagesAllowedForUrls[] = "ImagesAllowedForUrls";
const char kImagesBlockedForUrls[] = "ImagesBlockedForUrls";
const char kImportAutofillFormData[] = "ImportAutofillFormData";
const char kImportBookmarks[] = "ImportBookmarks";
const char kImportHistory[] = "ImportHistory";
const char kImportHomepage[] = "ImportHomepage";
const char kImportSavedPasswords[] = "ImportSavedPasswords";
const char kImportSearchEngine[] = "ImportSearchEngine";
const char kIncognitoEnabled[] = "IncognitoEnabled";
const char kIncognitoModeAvailability[] = "IncognitoModeAvailability";
const char kInstantEnabled[] = "InstantEnabled";
const char kInstantTetheringAllowed[] = "InstantTetheringAllowed";
const char kIsolateOrigins[] = "IsolateOrigins";
const char kIsolateOriginsAndroid[] = "IsolateOriginsAndroid";
const char kJavaScriptAllowedForUrls[] = "JavaScriptAllowedForUrls";
const char kJavaScriptBlockedForUrls[] = "JavaScriptBlockedForUrls";
const char kJavascriptEnabled[] = "JavascriptEnabled";
const char kKeyPermissions[] = "KeyPermissions";
const char kKeyboardDefaultToFunctionKeys[] = "KeyboardDefaultToFunctionKeys";
const char kKeygenAllowedForUrls[] = "KeygenAllowedForUrls";
const char kKeygenBlockedForUrls[] = "KeygenBlockedForUrls";
const char kLargeCursorEnabled[] = "LargeCursorEnabled";
const char kLidCloseAction[] = "LidCloseAction";
const char kLogUploadEnabled[] = "LogUploadEnabled";
const char kLoginAuthenticationBehavior[] = "LoginAuthenticationBehavior";
const char kLoginVideoCaptureAllowedUrls[] = "LoginVideoCaptureAllowedUrls";
const char kMachineLevelUserCloudPolicyEnrollmentToken[] = "MachineLevelUserCloudPolicyEnrollmentToken";
const char kManagedBookmarks[] = "ManagedBookmarks";
const char kMaxConnectionsPerProxy[] = "MaxConnectionsPerProxy";
const char kMaxInvalidationFetchDelay[] = "MaxInvalidationFetchDelay";
const char kMediaCacheSize[] = "MediaCacheSize";
const char kMediaRouterCastAllowAllIPs[] = "MediaRouterCastAllowAllIPs";
const char kMetricsReportingEnabled[] = "MetricsReportingEnabled";
const char kMinimumRequiredChromeVersion[] = "MinimumRequiredChromeVersion";
const char kNTPContentSuggestionsEnabled[] = "NTPContentSuggestionsEnabled";
const char kNativeMessagingBlacklist[] = "NativeMessagingBlacklist";
const char kNativeMessagingUserLevelHosts[] = "NativeMessagingUserLevelHosts";
const char kNativeMessagingWhitelist[] = "NativeMessagingWhitelist";
const char kNativePrinters[] = "NativePrinters";
const char kNativePrintersBulkAccessMode[] = "NativePrintersBulkAccessMode";
const char kNativePrintersBulkBlacklist[] = "NativePrintersBulkBlacklist";
const char kNativePrintersBulkConfiguration[] = "NativePrintersBulkConfiguration";
const char kNativePrintersBulkWhitelist[] = "NativePrintersBulkWhitelist";
const char kNetworkPredictionOptions[] = "NetworkPredictionOptions";
const char kNetworkThrottlingEnabled[] = "NetworkThrottlingEnabled";
const char kNewTabPageLocation[] = "NewTabPageLocation";
const char kNoteTakingAppsLockScreenWhitelist[] = "NoteTakingAppsLockScreenWhitelist";
const char kNotificationsAllowedForUrls[] = "NotificationsAllowedForUrls";
const char kNotificationsBlockedForUrls[] = "NotificationsBlockedForUrls";
const char kNtlmV2Enabled[] = "NtlmV2Enabled";
const char kOpenNetworkConfiguration[] = "OpenNetworkConfiguration";
const char kPacHttpsUrlStrippingEnabled[] = "PacHttpsUrlStrippingEnabled";
const char kPasswordManagerAllowShowPasswords[] = "PasswordManagerAllowShowPasswords";
const char kPasswordManagerEnabled[] = "PasswordManagerEnabled";
const char kPasswordProtectionChangePasswordURL[] = "PasswordProtectionChangePasswordURL";
const char kPasswordProtectionLoginURLs[] = "PasswordProtectionLoginURLs";
const char kPasswordProtectionWarningTrigger[] = "PasswordProtectionWarningTrigger";
const char kPinUnlockMaximumLength[] = "PinUnlockMaximumLength";
const char kPinUnlockMinimumLength[] = "PinUnlockMinimumLength";
const char kPinUnlockWeakPinsAllowed[] = "PinUnlockWeakPinsAllowed";
const char kPinnedLauncherApps[] = "PinnedLauncherApps";
const char kPluginsAllowedForUrls[] = "PluginsAllowedForUrls";
const char kPluginsBlockedForUrls[] = "PluginsBlockedForUrls";
const char kPolicyRefreshRate[] = "PolicyRefreshRate";
const char kPopupsAllowedForUrls[] = "PopupsAllowedForUrls";
const char kPopupsBlockedForUrls[] = "PopupsBlockedForUrls";
const char kPowerManagementIdleSettings[] = "PowerManagementIdleSettings";
const char kPowerManagementUsesAudioActivity[] = "PowerManagementUsesAudioActivity";
const char kPowerManagementUsesVideoActivity[] = "PowerManagementUsesVideoActivity";
const char kPresentationIdleDelayScale[] = "PresentationIdleDelayScale";
const char kPresentationScreenDimDelayScale[] = "PresentationScreenDimDelayScale";
const char kPrintPreviewUseSystemDefaultPrinter[] = "PrintPreviewUseSystemDefaultPrinter";
const char kPrintingEnabled[] = "PrintingEnabled";
const char kPromptForDownloadLocation[] = "PromptForDownloadLocation";
const char kProxyBypassList[] = "ProxyBypassList";
const char kProxyMode[] = "ProxyMode";
const char kProxyPacUrl[] = "ProxyPacUrl";
const char kProxyServer[] = "ProxyServer";
const char kProxyServerMode[] = "ProxyServerMode";
const char kProxySettings[] = "ProxySettings";
const char kQuicAllowed[] = "QuicAllowed";
const char kQuickUnlockModeWhitelist[] = "QuickUnlockModeWhitelist";
const char kQuickUnlockTimeout[] = "QuickUnlockTimeout";
const char kRC4Enabled[] = "RC4Enabled";
const char kRebootAfterUpdate[] = "RebootAfterUpdate";
const char kRegisteredProtocolHandlers[] = "RegisteredProtocolHandlers";
const char kRelaunchNotification[] = "RelaunchNotification";
const char kRelaunchNotificationPeriod[] = "RelaunchNotificationPeriod";
const char kRemoteAccessClientFirewallTraversal[] = "RemoteAccessClientFirewallTraversal";
const char kRemoteAccessHostAllowClientPairing[] = "RemoteAccessHostAllowClientPairing";
const char kRemoteAccessHostAllowGnubbyAuth[] = "RemoteAccessHostAllowGnubbyAuth";
const char kRemoteAccessHostAllowRelayedConnection[] = "RemoteAccessHostAllowRelayedConnection";
const char kRemoteAccessHostAllowUiAccessForRemoteAssistance[] = "RemoteAccessHostAllowUiAccessForRemoteAssistance";
const char kRemoteAccessHostClientDomain[] = "RemoteAccessHostClientDomain";
const char kRemoteAccessHostClientDomainList[] = "RemoteAccessHostClientDomainList";
const char kRemoteAccessHostDebugOverridePolicies[] = "RemoteAccessHostDebugOverridePolicies";
const char kRemoteAccessHostDomain[] = "RemoteAccessHostDomain";
const char kRemoteAccessHostDomainList[] = "RemoteAccessHostDomainList";
const char kRemoteAccessHostFirewallTraversal[] = "RemoteAccessHostFirewallTraversal";
const char kRemoteAccessHostMatchUsername[] = "RemoteAccessHostMatchUsername";
const char kRemoteAccessHostRequireCurtain[] = "RemoteAccessHostRequireCurtain";
const char kRemoteAccessHostRequireTwoFactor[] = "RemoteAccessHostRequireTwoFactor";
const char kRemoteAccessHostTalkGadgetPrefix[] = "RemoteAccessHostTalkGadgetPrefix";
const char kRemoteAccessHostTokenUrl[] = "RemoteAccessHostTokenUrl";
const char kRemoteAccessHostTokenValidationCertificateIssuer[] = "RemoteAccessHostTokenValidationCertificateIssuer";
const char kRemoteAccessHostTokenValidationUrl[] = "RemoteAccessHostTokenValidationUrl";
const char kRemoteAccessHostUdpPortRange[] = "RemoteAccessHostUdpPortRange";
const char kRenderInChromeFrameList[] = "RenderInChromeFrameList";
const char kRenderInHostList[] = "RenderInHostList";
const char kReportArcStatusEnabled[] = "ReportArcStatusEnabled";
const char kReportDeviceActivityTimes[] = "ReportDeviceActivityTimes";
const char kReportDeviceBootMode[] = "ReportDeviceBootMode";
const char kReportDeviceHardwareStatus[] = "ReportDeviceHardwareStatus";
const char kReportDeviceLocation[] = "ReportDeviceLocation";
const char kReportDeviceNetworkInterfaces[] = "ReportDeviceNetworkInterfaces";
const char kReportDeviceSessionStatus[] = "ReportDeviceSessionStatus";
const char kReportDeviceUsers[] = "ReportDeviceUsers";
const char kReportDeviceVersionInfo[] = "ReportDeviceVersionInfo";
const char kReportUploadFrequency[] = "ReportUploadFrequency";
const char kRequireOnlineRevocationChecksForLocalAnchors[] = "RequireOnlineRevocationChecksForLocalAnchors";
const char kRestoreOnStartup[] = "RestoreOnStartup";
const char kRestoreOnStartupURLs[] = "RestoreOnStartupURLs";
const char kRestrictAccountsToPatterns[] = "RestrictAccountsToPatterns";
const char kRestrictSigninToPattern[] = "RestrictSigninToPattern";
const char kRoamingProfileLocation[] = "RoamingProfileLocation";
const char kRoamingProfileSupportEnabled[] = "RoamingProfileSupportEnabled";
const char kRunAllFlashInAllowMode[] = "RunAllFlashInAllowMode";
const char kSAMLOfflineSigninTimeLimit[] = "SAMLOfflineSigninTimeLimit";
const char kSSLErrorOverrideAllowed[] = "SSLErrorOverrideAllowed";
const char kSSLVersionFallbackMin[] = "SSLVersionFallbackMin";
const char kSSLVersionMax[] = "SSLVersionMax";
const char kSSLVersionMin[] = "SSLVersionMin";
const char kSafeBrowsingEnabled[] = "SafeBrowsingEnabled";
const char kSafeBrowsingExtendedReportingEnabled[] = "SafeBrowsingExtendedReportingEnabled";
const char kSafeBrowsingExtendedReportingOptInAllowed[] = "SafeBrowsingExtendedReportingOptInAllowed";
const char kSafeBrowsingForTrustedSourcesEnabled[] = "SafeBrowsingForTrustedSourcesEnabled";
const char kSafeBrowsingWhitelistDomains[] = "SafeBrowsingWhitelistDomains";
const char kSavingBrowserHistoryDisabled[] = "SavingBrowserHistoryDisabled";
const char kScreenDimDelayAC[] = "ScreenDimDelayAC";
const char kScreenDimDelayBattery[] = "ScreenDimDelayBattery";
const char kScreenLockDelayAC[] = "ScreenLockDelayAC";
const char kScreenLockDelayBattery[] = "ScreenLockDelayBattery";
const char kScreenLockDelays[] = "ScreenLockDelays";
const char kScreenMagnifierType[] = "ScreenMagnifierType";
const char kScreenOffDelayAC[] = "ScreenOffDelayAC";
const char kScreenOffDelayBattery[] = "ScreenOffDelayBattery";
const char kSearchSuggestEnabled[] = "SearchSuggestEnabled";
const char kSecondaryGoogleAccountSigninAllowed[] = "SecondaryGoogleAccountSigninAllowed";
const char kSecurityKeyPermitAttestation[] = "SecurityKeyPermitAttestation";
const char kSessionLengthLimit[] = "SessionLengthLimit";
const char kSessionLocales[] = "SessionLocales";
const char kShelfAutoHideBehavior[] = "ShelfAutoHideBehavior";
const char kShowAccessibilityOptionsInSystemTrayMenu[] = "ShowAccessibilityOptionsInSystemTrayMenu";
const char kShowAppsShortcutInBookmarkBar[] = "ShowAppsShortcutInBookmarkBar";
const char kShowCastIconInToolbar[] = "ShowCastIconInToolbar";
const char kShowHomeButton[] = "ShowHomeButton";
const char kShowLogoutButtonInTray[] = "ShowLogoutButtonInTray";
const char kSigninAllowed[] = "SigninAllowed";
const char kSitePerProcess[] = "SitePerProcess";
const char kSitePerProcessAndroid[] = "SitePerProcessAndroid";
const char kSkipMetadataCheck[] = "SkipMetadataCheck";
const char kSpellCheckServiceEnabled[] = "SpellCheckServiceEnabled";
const char kSpellcheckEnabled[] = "SpellcheckEnabled";
const char kSpellcheckLanguage[] = "SpellcheckLanguage";
const char kSpokenFeedbackEnabled[] = "SpokenFeedbackEnabled";
const char kSupervisedUserContentProviderEnabled[] = "SupervisedUserContentProviderEnabled";
const char kSupervisedUserCreationEnabled[] = "SupervisedUserCreationEnabled";
const char kSupervisedUsersEnabled[] = "SupervisedUsersEnabled";
const char kSuppressChromeFrameTurndownPrompt[] = "SuppressChromeFrameTurndownPrompt";
const char kSuppressUnsupportedOSWarning[] = "SuppressUnsupportedOSWarning";
const char kSyncDisabled[] = "SyncDisabled";
const char kSystemTimezone[] = "SystemTimezone";
const char kSystemTimezoneAutomaticDetection[] = "SystemTimezoneAutomaticDetection";
const char kSystemUse24HourClock[] = "SystemUse24HourClock";
const char kTPMFirmwareUpdateSettings[] = "TPMFirmwareUpdateSettings";
const char kTabUnderAllowed[] = "TabUnderAllowed";
const char kTaskManagerEndProcessEnabled[] = "TaskManagerEndProcessEnabled";
const char kTermsOfServiceURL[] = "TermsOfServiceURL";
const char kThirdPartyBlockingEnabled[] = "ThirdPartyBlockingEnabled";
const char kTouchVirtualKeyboardEnabled[] = "TouchVirtualKeyboardEnabled";
const char kTranslateEnabled[] = "TranslateEnabled";
const char kURLBlacklist[] = "URLBlacklist";
const char kURLWhitelist[] = "URLWhitelist";
const char kUnaffiliatedArcAllowed[] = "UnaffiliatedArcAllowed";
const char kUnifiedDesktopEnabledByDefault[] = "UnifiedDesktopEnabledByDefault";
const char kUnsafelyTreatInsecureOriginAsSecure[] = "UnsafelyTreatInsecureOriginAsSecure";
const char kUptimeLimit[] = "UptimeLimit";
const char kUsageTimeLimit[] = "UsageTimeLimit";
const char kUsbDetachableWhitelist[] = "UsbDetachableWhitelist";
const char kUserActivityScreenDimDelayScale[] = "UserActivityScreenDimDelayScale";
const char kUserAvatarImage[] = "UserAvatarImage";
const char kUserDataDir[] = "UserDataDir";
const char kUserDisplayName[] = "UserDisplayName";
const char kUserNativePrintersAllowed[] = "UserNativePrintersAllowed";
const char kVariationsRestrictParameter[] = "VariationsRestrictParameter";
const char kVideoCaptureAllowed[] = "VideoCaptureAllowed";
const char kVideoCaptureAllowedUrls[] = "VideoCaptureAllowedUrls";
const char kVirtualKeyboardEnabled[] = "VirtualKeyboardEnabled";
const char kVirtualMachinesAllowed[] = "VirtualMachinesAllowed";
const char kWPADQuickCheckEnabled[] = "WPADQuickCheckEnabled";
const char kWaitForInitialUserActivity[] = "WaitForInitialUserActivity";
const char kWallpaperImage[] = "WallpaperImage";
const char kWebDriverOverridesIncompatiblePolicies[] = "WebDriverOverridesIncompatiblePolicies";
const char kWebRestrictionsAuthority[] = "WebRestrictionsAuthority";
const char kWebRtcUdpPortRange[] = "WebRtcUdpPortRange";
const char kWebUsbAskForUrls[] = "WebUsbAskForUrls";
const char kWebUsbBlockedForUrls[] = "WebUsbBlockedForUrls";
const char kWelcomePageOnOSUpgradeEnabled[] = "WelcomePageOnOSUpgradeEnabled";

}  // namespace key

}  // namespace policy
